#include "Tlc5940.h"
    
/*10 = SIN    PWM - TLC Pin 5    >3? hm ...
 1 = SCLK       - TLC Pin 4  
14 = XLAT   PWM - TLC Pin 3  ok
15 = BLNK   PWM - TLC Pin 2  ok
 9 = GSCLK  PWM - TLC Pin 25 ok


7,6,5,4
*/

boolean debugInput=false;
boolean debugSending=false;
boolean debugMidi=false;
boolean debugController=false;
boolean debugHarmInput=false;

int theChannelPointer;
byte myHarmChannels[8][2]={{1,2},{3,4},{5,6},{7,8},{9,10},{11,12},{13,14},{15,16}};
byte channel = 1;                                              // default main channel
byte myHarmChannel[2] = {1,2};                                 // default channels for harmony


// variable for clock
byte counter;
long noteCounter;
byte CLOCK = 248;
byte START = 250;
byte CONTINUE = 251;
byte STOP = 252;


int clockPin=0;
// additional LEDs attached to pin 8
int onboardLedPin=8;
int dipPins[4]={7,6,5,4};                                     // pins of channel selection
int ctrPins[6]={A0,A1,A2,A3,A4,A5};                           // pins of the controller - analog names
int ctrPinsDO[6]={21,20,19,18,17,16};                         // pins of the controller - digital names
int ctrOutPins[6]={13,14,15,5,4,3};                           // pins of the TLC5940 to send outputs
byte ctrMidiControllers[8][6]={{1,2,3,4,5,6},{7,8,9,10,11,12},{13,14,15,16,17,18},{19,20,21,22,23,24},{25,26,27,28,29,30},{31,32,33,34,35,36},{37,38,39,40,41,42},{43,44,45,46,47,48}}; //{46,47,16,17,18,19};                // MIDI controller numbers (used to transmit the changes)
int notePins[2]={A11,A9};                                     // pins of the notes - analog names
int notePinsDO[2]={22,12};                                    // pins of the notes - digital names
int noteOutPins[2]={7,11};                                    // pins of the TLC5940 to send outputs
int velocityOutPins[2]={6,12};                                // pins of the velocity - analog names
int velocityPins[2]={A10,A8};                                 // pins of the velocity - analog names
int velocityPinsDO[2]={11,13};                                // pins of the TLC5940 to send outputs

int ctrValues[6];                                             // storing the controller values (7 bit midi range)
int ctrAnalogValues[6];                                       // storing the controller values (11 bit range)
int ctrAnalogValueStorageSize=64;                             // how much entries for the average generation
int ctrAnalogValueStorage[6][64];                             // storage for the average generation
long ctrAnalogValueAverage[6];                                 // the average value
int ctrValuesLast[6];                                         // storing the last value

int velocityValues[2];                                        // storing the controller values (7 bit midi range)
int velocityAnalogValues[2];                                  // storing the controller values (11 bit range)
int velocityAnalogValueStorageSize=64;                        // how much entries for the average generation
int velocityAnalogValueStorage[2][64];                        // storage for the average generation
long velocityAnalogValueAverage[2];                            // the average value
int velocityValuesLast[2];                                    // storing the last value

int noteValues[2];                                            // storing the controller values (7 bit midi range)
int noteAnalogValues[2];                                      // storing the controller values (11 bit range)
int noteAnalogValueStorageSize=64;                            // how much entries for the average generation
int noteAnalogValueStorage[2][64];                            // storage for the average generation
long noteAnalogValueAverage[2];                                // the average value
int noteValuesLast[2];                                        // storing the last value

int currentNote[2]={0,0};                                     // which note is selected
int lastNoteValues[2]={0,0};                                  // which note was the last one
int lastVelocityValues[2]={0,0};                              // what was the last velocity
boolean noteOn[2]={0,0};                                      // is a note playing?

int treashold=0;
int noteOffTreashold=5;
int velocityOffTreashold=5;
int velocityChangeTreashold=5;


void setup() {
  Serial.begin(115200);
  usbMIDI.setHandleRealTimeSystem(RealTimeSystem);  // starting Midi Clock
  usbMIDI.setHandleControlChange(myControlChange);
  pinMode(clockPin, OUTPUT);
  digitalWrite(clockPin, HIGH);
  for (int i=0; i<6; i++){
    pinMode(ctrPinsDO[i], INPUT_PULLUP);
  }
  
  for (int i=0; i<2; i++){
    pinMode(velocityPinsDO[i], INPUT_PULLUP);    
    pinMode(notePinsDO[i], INPUT_PULLUP);  
  }
  Tlc.init();
  Tlc.clear();
  
  // inti control storage
  for (int i=0; i<6; i++){
    for (int j=0; j<ctrAnalogValueStorageSize-1; j++){
      ctrAnalogValueStorage[i][j]=0;
    }
  }
  
  // init dip pins
  for (int i=0; i<4; i++){
    pinMode(dipPins[i], INPUT_PULLUP);
  }  
  
  pinMode(onboardLedPin,OUTPUT);
  digitalWrite(onboardLedPin,HIGH);  
  
} 

void getMyChannels(){
  theChannelPointer=(digitalRead(dipPins[3])*8)+(digitalRead(dipPins[2])*4)+(digitalRead(dipPins[1])*2)+digitalRead(dipPins[0]);
  if (theChannelPointer>7) theChannelPointer=7;
  channel = myHarmChannels[theChannelPointer][0];
  myHarmChannel[0]= myHarmChannels[theChannelPointer][0];
  myHarmChannel[1]= myHarmChannels[theChannelPointer][1];
}

void loop() {
  int startMillis=millis();
  getMyChannels();
  usbMIDI.read();
  controlReading();
  harmonicReading();
  outputSending();
  int endMillis=millis();
  //Serial.println(endMillis-startMillis);
}

int exponential(int base, int exponent){
  int myAnswer=1;
  myAnswer=pow(base,exponent);
  if (exponent>0){
    for (int k=1; k<exponent; k++){
      myAnswer=myAnswer*base;
    }
  } else {
    myAnswer=0;
  }
  return myAnswer;
}
